#define F_CPU 12000000L

#include <avr\io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#define HRANICE 18/40										//konstanta definujc rozdl okol na opt. svazku
#define POM 10												//konstanta definujc citlivost, kdy se m senzor posunout
#define ZPOZD 0
#define ZPOZDENI 1000
#define FOSC 12000000                 						// rychlost CPU
#define BAUD 250000                 						// rychlost prenosu
#define WRITE 0b00101010									// zapis z PGA
#define READ 0b01101010										// cteni z PGA	
#define MAX 2200									        // maximum vychylky motoru
#define KROK 40												// krok pri hledani svazku 
#define SKOK 40											    // skok pri rucnim posunu

//prototypy funkc:
uint16_t zapis( uint8_t data8,uint16_t j ); 				//prototyp funkce zapsani do pameti
void krok_x(int x, int z ); 								//prototyp funkce posunu motoru v x ose
void krok_y( int x, int z ); 								//prototyp funkce posunu motoru v y ose
void usart_init(void);										//inicializace usart
void adc_init(void);										//inicializace ADC
void spi_init(void);										//inicializace SPI
uint8_t prevod (uint8_t vstup);								//zjitn zeslen
uint16_t zesileni(uint8_t zes,uint8_t vstup);				//potebn zeslen
void write_spi(uint8_t povel, uint8_t prikaz);				//komunikace s PGA
void posli(int x, int y,int nas, int LH,int PH, int LD, int PD);  // odesln paketu k PC

//globln promn
volatile char start=0; 						//promene pro rizeni
volatile char odeslano=0, odeslanoADC=0,potvrzeni=1, oprava=0;
volatile uint8_t receivedchar, low_bit=0, hight_bit=0; 
 


/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------main---------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

int main(void)
{	uint16_t vstup_1=0,vstup_2=0,vstup_3=0,vstup_4=0,nejvetsi = 0,okoli_1=0;
	uint8_t i=0;
	char ano=0,dopredu=1,chytlo=1; 
	int y=1,x=1,zes=0,b=0;
	DDRB=0b00001111;
	DDRC=0b11111110;
	PORTB=0b00000000;
	PORTC=0b00000010;
	usart_init();
	usart_init();
	adc_init();
	spi_init();
	sei();													//povolen preruseni
	
	
	
	while (1)
	{	//posln pkaz "s"
		if(start==0b00000001)
			{
			if (!(ano==1))										//zmereni napetich umerne intenzite svetla na kvadrantech v bod 1,1
				{												//a pesun do bodu 1,2200.
					vstup_1=prevod(0b00000011);
					vstup_2=prevod(0b00000001);
					vstup_3=prevod(0b00000010);
					vstup_4=prevod(0b00000000);
					if ((vstup_1<=vstup_2)&&(vstup_1<=vstup_3)&&(vstup_1<=vstup_4))
						zes=vstup_1;
						else if ((vstup_2<=vstup_1)&&(vstup_2<=vstup_3)&&(vstup_2<=vstup_4))
								zes=vstup_2;			
							else if ((vstup_3<=vstup_1)&&(vstup_3<=vstup_2)&&(vstup_3<=vstup_4))
									zes=vstup_3;
								else if ((vstup_4<=vstup_1)&&(vstup_4<=vstup_2)&&(vstup_4<=vstup_3))
										zes=vstup_4;
					vstup_1=zesileni(zes,0b00000011);
					vstup_2=zesileni(zes,0b00000001);
					vstup_3=zesileni(zes,0b00000010);
					vstup_4=zesileni(zes,0b00000000);
					posli(x , y,zes, vstup_1,vstup_2, vstup_3, vstup_4);
					okoli_1=(vstup_1+vstup_2+vstup_3+vstup_4)/4;
					posli(x , y,zes,okoli_1,0, 0, 0);
			        while (!(x==(MAX)))																
							{																		
							krok_x(x,0);															
							if (x%40==0)
							posli(x , y,1, 0,0, 0, 0);
							
							x++;
							}
					
					vstup_1=prevod(0b00000011);														//zmereni napetich umerne intenzite svetla na kvadrantech v bod 1,2200
					vstup_2=prevod(0b00000001);														//a pesun do bodu 2200,2200.
					vstup_3=prevod(0b00000010);
					vstup_4=prevod(0b00000000);
					if ((vstup_1<=vstup_2)&&(vstup_1<=vstup_3)&&(vstup_1<=vstup_4))
						zes=vstup_1;
						else if ((vstup_2<=vstup_1)&&(vstup_2<=vstup_3)&&(vstup_2<=vstup_4))
								zes=vstup_2;			
							else if ((vstup_3<=vstup_1)&&(vstup_3<=vstup_2)&&(vstup_3<=vstup_4))
									zes=vstup_3;
								else if ((vstup_4<=vstup_1)&&(vstup_4<=vstup_2)&&(vstup_4<=vstup_3))
										zes=vstup_4;
					vstup_1=zesileni(zes,0b00000011);
					vstup_2=zesileni(zes,0b00000001);
					vstup_3=zesileni(zes,0b00000010);
					vstup_4=zesileni(zes,0b00000000);
					posli(x , y,zes, vstup_1,vstup_2, vstup_3, vstup_4);
					okoli_1=(okoli_1+(vstup_1+vstup_2+vstup_3+vstup_4)/4)/2;
					posli(x , y,zes,okoli_1,0, 0, 0);
					while (!(y==MAX))
								{
								 krok_y(y,0);
								
								if (y%40==0)
								posli(x , y,1, 0,0, 0, 0);
								
				
								y++;
								}
					
					vstup_1=prevod(0b00000011);													//zmereni napetich umerne intenzite svetla na kvadrantech v bod 2200,2200
					vstup_2=prevod(0b00000001);													//a pesun do bodu 1,2200.
					vstup_3=prevod(0b00000010);
					vstup_4=prevod(0b00000000);
					if ((vstup_1<=vstup_2)&&(vstup_1<=vstup_3)&&(vstup_1<=vstup_4))
						zes=vstup_1;
						else if ((vstup_2<=vstup_1)&&(vstup_2<=vstup_3)&&(vstup_2<=vstup_4))
								zes=vstup_2;			
							else if ((vstup_3<=vstup_1)&&(vstup_3<=vstup_2)&&(vstup_3<=vstup_4))
									zes=vstup_3;
								else if ((vstup_4<=vstup_1)&&(vstup_4<=vstup_2)&&(vstup_4<=vstup_3))
										zes=vstup_4;
					vstup_1=zesileni(zes,0b00000011);
					vstup_2=zesileni(zes,0b00000001);
					vstup_3=zesileni(zes,0b00000010);
					vstup_4=zesileni(zes,0b00000000);
					posli(x , y,zes, vstup_1,vstup_2, vstup_3, vstup_4);
					okoli_1=(okoli_1+(vstup_1+vstup_2+vstup_3+vstup_4)/4)/2;
					posli(x , y,zes,okoli_1,0, 0, 0);
					while (!(x==0))															
						{
						krok_x(x,0);
						if (x%40==0)
						posli(x , y,1, 0,0, 0, 0);
						
						x--;
						}
						x++;
					vstup_1=prevod(0b00000011);										//zmereni napetich umerne intenzite svetla na kvadrantech v bod 1,2200
					vstup_2=prevod(0b00000001);										//a pesun do bodu 1,1.
					vstup_3=prevod(0b00000010);
					vstup_4=prevod(0b00000000);
					if ((vstup_1<=vstup_2)&&(vstup_1<=vstup_3)&&(vstup_1<=vstup_4))
						zes=vstup_1;
						else if ((vstup_2<=vstup_1)&&(vstup_2<=vstup_3)&&(vstup_2<=vstup_4))
								zes=vstup_2;			
							else if ((vstup_3<=vstup_1)&&(vstup_3<=vstup_2)&&(vstup_3<=vstup_4))
									zes=vstup_3;
								else if ((vstup_4<=vstup_1)&&(vstup_4<=vstup_2)&&(vstup_4<=vstup_3))
										zes=vstup_4;
					vstup_1=zesileni(zes,0b00000011);
					vstup_2=zesileni(zes,0b00000001);
					vstup_3=zesileni(zes,0b00000010);
					vstup_4=zesileni(zes,0b00000000);
					posli(x , y,zes, vstup_1,vstup_2, vstup_3, vstup_4);
					okoli_1=(okoli_1+(vstup_1+vstup_2+vstup_3+vstup_4)/4)/2;
					posli(x , y,zes,okoli_1,0, 0, 0);	
					
					while (!(y==0))																
						{
						krok_y(y,0);
						if (y%40==0)
						posli(x , y,1, 0,0, 0, 0);
				
						y--;
						}
					y++;
					ano=1;
					
					}
					
				
				//men vech tyech hodnot							
				vstup_1=prevod(0b00000011);																//zjitn nejvtho zeslen
				vstup_2=prevod(0b00000001);
				vstup_3=prevod(0b00000010);
				vstup_4=prevod(0b00000000);
				if ((vstup_1<=vstup_2)&&(vstup_1<=vstup_3)&&(vstup_1<=vstup_4))
					zes=vstup_1;
				else if ((vstup_2<=vstup_1)&&(vstup_2<=vstup_3)&&(vstup_2<=vstup_4))
						zes=vstup_2;			
					else if ((vstup_3<=vstup_1)&&(vstup_3<=vstup_2)&&(vstup_3<=vstup_4))
							zes=vstup_3;
						else if ((vstup_4<=vstup_1)&&(vstup_4<=vstup_2)&&(vstup_4<=vstup_3))
								zes=vstup_4;
						
				vstup_1=zesileni(zes,0b00000011);														//zjitn napt na segmentech po zeslen
				vstup_2=zesileni(zes,0b00000001);
				vstup_3=zesileni(zes,0b00000010);
				vstup_4=zesileni(zes,0b00000000);
				
							
			if ((vstup_1<=vstup_2)&&(vstup_1<=vstup_3)&&(vstup_1<=vstup_4))								//zjitn kvadrantu s nejvt naptm 
					nejvetsi=vstup_1;
				else if ((vstup_2<=vstup_1)&&(vstup_2<=vstup_3)&&(vstup_2<=vstup_4))
						nejvetsi=vstup_2;			
					else if ((vstup_3<=vstup_1)&&(vstup_3<=vstup_2)&&(vstup_3<=vstup_4))
							nejvetsi=vstup_3;
						else if ((vstup_4<=vstup_1)&&(vstup_4<=vstup_2)&&(vstup_4<=vstup_3))
								nejvetsi=vstup_4;				

				
				
				

				if(((okoli_1)>(nejvetsi*HRANICE))&&(chytlo==1))   //rozhodnut jestli vyhledvat nebo sledovat paprsek
					{
					while ((x%40)!=1)
						{	if (x>1)
							{	
							krok_x(x,ZPOZD);
							x--;
							}
						}
					while ((y%40)!=1)
						{	if (x>1)
							{
							krok_y(y,ZPOZD);
							y--;
							}
						}
																					
					if (dopredu==1)				//posunu o krok vedle
						{if (x<MAX) 
							{i=KROK;
							while (i>0)
								{i--;
								krok_x(x,ZPOZD);
								x++;
								
								}
							posli(x , y,zes, vstup_1,vstup_2, vstup_3, vstup_4);
							}
						
						else 
							{if (y<MAX) 		//pokud jsem nakonci posunu dolu
								{i=KROK;
								while (i>0)
									{i--;
									krok_y(y,ZPOZD);
									y++;
									
									}
								posli(x , y,zes, vstup_1,vstup_2, vstup_3, vstup_4);
							 	dopredu=0;
								}
							else  
							 	{loop_until_bit_is_set(UCSRA,UDRE);			//paprsek nenalezen a zaslana hlaska o erroru
								UDR='N';
								start=0b00000010;
								}
							}
						}
					else 						//vraci se vodorovne zpet 
						{
						if (x>1) 
							{i=KROK;
							while (i>0)
								{i--;
								krok_x(x,ZPOZD);
								x--;
								
								}
							posli(x , y,zes, vstup_1,vstup_2, vstup_3, vstup_4);
							}
						else 
							if (y<MAX) 		//na zacatku drahy jde senzor dolu 
								{i=KROK;
								while (i>0)
									{i--;
									krok_y(y,ZPOZD);
									y++;
									
									}
								posli(x , y,zes, vstup_1,vstup_2, vstup_3, vstup_4);
								dopredu=1;
								
								}
						}
			}
				
			else {
				chytlo=0; //podmnka, kdy se chytnetak, se u dr vhodn pro siln lasery
			
			if ((vstup_1+vstup_2)<(vstup_3+vstup_4)-POM)			//zapojeno tak, ze 1 a 2 je leva cast a 3 a 4 je prava cast
							{if (x>1) 
								{
								krok_x(x,ZPOZD);
								x--;
								krok_x(x,ZPOZD);
								x--;
								krok_x(x,ZPOZD);
								x--;
								krok_x(x,ZPOZD);
								x--;
								} 
							}
			if ((vstup_1+vstup_2)>(vstup_3+vstup_4)+POM)
							{if (x<MAX) 
								{
								krok_x(x,ZPOZD);
								x++;
								krok_x(x,ZPOZD);
								x++;
								krok_x(x,ZPOZD);
								x++;
								krok_x(x,ZPOZD);
								x++;
								}
								 
							} 
			if ((vstup_1+vstup_3)<(vstup_2+vstup_4)-POM)			//zapojeno tak, ze 1 a 2 je leva cast a 3 a 4 je prava cast
							{if (y>1) 
								{
								krok_y(y,ZPOZD);
								y--;
								krok_y(y,ZPOZD);
								y--;
								krok_y(y,ZPOZD);
								y--;
								krok_y(y,ZPOZD);
								y--;
								}
							}
			if ((vstup_1+vstup_3)>(vstup_2+vstup_4)+POM)
							{if (y<MAX) 
								{
								krok_y(y,ZPOZD);
								y++;
								krok_y(y,ZPOZD);
								y++;
								krok_y(y,ZPOZD);
								y++;
								krok_y(y,ZPOZD);
								y++;
								}
							}
			posli(x , y,zes, vstup_1,vstup_2, vstup_3, vstup_4);
			} 
						
		}

		
		
		
		
		
		//vraci senzor na zacatek drahy
		
		if(start==0b00000010)
			{
			while (!(x==1))
				{
				 krok_x(x,0);
				x--;
				if (x%40==0)
				posli(x , y,1, 0,0, 0, 0);
				
				}
			while (!(y==1))
				{
				 krok_y(y,0);
				y--;
				if (y%40==0)
				posli(x , y,1, 0,0, 0, 0);
				
				}
			dopredu=1;
			ano=0;
			b=0;
			chytlo=1;
			posli(x , y,1, 0,0, 0, 0);
			
			
			start=0b00000000;
				

						}

		//posunuti senzoru doprava
		if(start==0b00000100)
			{if (x<MAX) 
				{i=SKOK;
				while (i>0)
					{i--;
					
					krok_x(x,0);
					x++;
					}
				posli(x , y,1, 0,0, 0, 0);
				
				} 
			else {
					loop_until_bit_is_set(UCSRA,UDRE);			//prilis blizko kraje, zaslan error
					UDR='H';
					}
			start=0b00000000;	
			
			}
		//posunuti senzoru doleva
		if(start==0b00001000)
			{if (x>(0+SKOK)) 
				{i=SKOK;
				while (i>0)
					{i--;
					
					krok_x(x,0);
					x--;
					}
				posli(x , y,1, 0,0, 0, 0);
				
				} 
			else {
					loop_until_bit_is_set(UCSRA,UDRE);			//prilis blizko kraje, zaslan error
					UDR='H';
					}
				
			start=0b00000000;
			}



			//posunuti senzoru dolu
			if(start==0b00010000)
			{if (y<MAX) 
				{i=SKOK;
				while (i>0)
					{i--;
					
					krok_y(y,0);
					y++;
					}
				posli(x , y,1, 0,0, 0, 0);
			
				} 
			else {
					loop_until_bit_is_set(UCSRA,UDRE);			//prilis blizko kraje, zaslan error
					UDR='H';
					}
				
			start=0b00000000;
			}
			//posunuti senzoru nahoru
		if(start==0b00100000)
			{if (y>(0+SKOK)) 
				{i=SKOK;
				while (i>0)
					{i--;
					
					krok_y(y,0);
					y--;}
				posli(x , y,1, 0,0, 0, 0);
			
				} 
			else {
					loop_until_bit_is_set(UCSRA,UDRE);			//prilis blizko kraje, zaslan error
					UDR='H';
					}
				
			start=0b00000000;
			}

	} 
}	
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/



/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------nastaveni USART----------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
void usart_init(void)
{	UCSRB=(1<<TXEN|1<<RXEN|1<<RXCIE);         				// povoleni prijimani, vysilani a preruseni  UART, 
 	UCSRC=(3<<UCSZ0|1<<USBS|1<<URSEL);      				//8bit slovo, 2 stop bity 
 	UBRRL=FOSC/16/BAUD-1;                                   // NASTAVENI RYCHLOSTI prenosu reg1
 	UBRRH=((FOSC/16/BAUD-1)>>8);                        	// NASTAVENI RYCHLOSTI prenosu reg2
}
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/



/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------nastaveni AD prevodniku--------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

void adc_init(void)
{	ADMUX&=~(1<<REFS0);               						//nastaveni reference a vstupu ADC
	ADCSRA=(1<<ADEN|1<<ADIE|1<<ADPS2|1<<ADPS1);
}
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------nastaveni SPI-------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
void spi_init(void)
{
	DDRB|=(1<<DDB3|1<<DDB4|1<<DDB5|1<<DDB7);
	PORTB|=(1<<PB3|1<<PB4);
	SPCR|=(1<<SPE|1<<MSTR|1<<SPIE|1<<SPR1|1<<SPR0);
	//SPSR|=(1<<SPI2X);
}

/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/



/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------ovladani motoru X--------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

void krok_x(int x, int z )
	{
					
					
	switch (x%4){
		case 0:{PORTB|=0b00000001;PORTC|=0b00001000;} break;
		case 1:{PORTB|=0b00000010;PORTC|=0b00001000;} break;
		case 2:{PORTB|=0b00000010;PORTC|=0b00000100;} break;
		case 3:{PORTB|=0b00000001;PORTC|=0b00000100;} break;
		}
		_delay_us(ZPOZDENI-z);
		PORTB&=~(1<<PB0|1<<PB1);
		PORTC&=~(1<<PC3|1<<PC2);
}
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/



/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*------------------------------------------------------------------------------ovladani motoru Y-----------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

void krok_y(int y, int z )
	{	
				
	switch (y%4){
		case 0:{PORTC|=0b10010000;} break;
		case 1:{PORTC|=0b10100000;} break;
		case 2:{PORTC|=0b01100000;} break;
		case 3:{PORTC|=0b01010000;} break;
		}
		_delay_us(ZPOZDENI-z);
		PORTC&=~(1<<PB7|1<<PB6|1<<PB5|1<<PB4);
}
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*------------------------------------------------------------------------------preruseni SPI---------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
ISR(SPI_STC_vect)
{
odeslano++;
}
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------preruseniADC-----------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
ISR(ADC_vect)
{
low_bit=ADCL;
hight_bit=ADCH;	
odeslanoADC++;
}
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/



/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*------------------------------------------------------------------------------Preruseni diky komunikaci USART---------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

ISR(USART_RXC_vect)											//preruseni diky prijmu usart
{
uint8_t  i=24;

switch (UDR)
		{
		case 'e':
				oprava=0;
				
				break;
		case 'g':
				potvrzeni=0;
				
				break;		
			
		case 's':
				start=0b00000001;
				
				break;

		case 'p':
				start=0b00000000;
				
				break;
		
		case 'k':
				start=0b00000010;
				
				break;
		
					 
				
		case '>':
				 start=0b00000100;
		
				break;
		case '<':
				 start=0b00001000;
				
				
				
				break;
		case 'n':
				 start=0b00100000;
			
				; 
					
				break;
		case 'd': 
				 start=0b00010000;
				
				
				break;
		case 'x':
				 while (i>0)
					{
					
					i--;
					krok_x(i,0);
					}
				 
				break;
		case 'y':
				
					while (i>0)
					{
					i--;
					krok_y(i,0);
					}
				 
				break;
		}
	
}
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------------funkce pro prevod a nastaveni zesileni------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

uint8_t prevod (uint8_t vstup)
{   
	
				
	write_spi(WRITE, vstup);
	
	ADCSRA|=(1<<ADSC);	   //nastaveni zesileni
	while(!odeslanoADC);
	odeslanoADC=0;
	
	uint8_t zess=0;
	
	//zjisti potrebne zesileni
	
	
	if(((hight_bit==1)&&(low_bit<224))||(hight_bit==0))
		{zess=2;
		if ((hight_bit==0)&&(low_bit<200))
			{zess=5;
			if((hight_bit==0)&&(low_bit<102))
				{zess=10;
				if((hight_bit==0)&&(low_bit<51))
					{zess=20;
					if((hight_bit==0)&&(low_bit<20))
						{zess=50;
						if((hight_bit==0)&&(low_bit<10))
							{zess=100;
							if((hight_bit==0)&&(low_bit<5))
								zess=200;
							}
						}
					
					}
				
				}
				
			}
		
		}
	

	return (zess);
}
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/





/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------funkce pro konecne zesileni----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
uint16_t zesileni(uint8_t zes,uint8_t vstup)
{	
	switch(zes)
			{case 200:zes=0b01110000|vstup; break;
			 case 100:zes=0b01100000|vstup; break;
			 case 50: zes=0b01010000|vstup; break;
			 case 20: zes=0b01000000|vstup; break;
			 case 10: zes=0b00110000|vstup; break;
			 case 5:  zes=0b00100000|vstup; break;
			 case 2:  zes=0b00010000|vstup; break;
			 case 1:  zes=0b00000000|vstup; break;
			}
	
	write_spi(WRITE, zes);				
	
	ADCSRA|=(1<<ADSC);	
	while(!odeslanoADC);
	odeslanoADC=0;
	
	return ((low_bit+(hight_bit<<8)));   	//vypocitani hodnoty 

}
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------Poslani retezce----------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

void posli(int x , int y,int nas, int LH,int PH, int LD, int PD)
{
	do {
	loop_until_bit_is_set(UCSRA,UDRE);			//posle zahajovaci byte
	UDR='Z';
	
	
	loop_until_bit_is_set(UCSRA,UDRE);			//posle x souradnici
	UDR=x;
	loop_until_bit_is_set(UCSRA,UDRE);			
	UDR=x>>8;
	
	loop_until_bit_is_set(UCSRA,UDRE);			//posle y souradnici
	UDR=y;
	loop_until_bit_is_set(UCSRA,UDRE);			
	UDR=y>>8;
	
	loop_until_bit_is_set(UCSRA,UDRE);			//posle zesileni
	UDR=nas;
	
	
	loop_until_bit_is_set(UCSRA,UDRE);			//posle hodnotu 1 segmentu
	UDR=LH;
	loop_until_bit_is_set(UCSRA,UDRE);			
	UDR=LH>>8;
	
	loop_until_bit_is_set(UCSRA,UDRE);			//prilis hodnotu 2 segmentu
	UDR=PH;
	loop_until_bit_is_set(UCSRA,UDRE);			
	UDR=PH>>8;
	loop_until_bit_is_set(UCSRA,UDRE);			//prilis hodnotu 3 segmentu
	UDR=LD;
	loop_until_bit_is_set(UCSRA,UDRE);			
	UDR=LD>>8;
	
	loop_until_bit_is_set(UCSRA,UDRE);			//prilis hodnotu 4 segmentu
	UDR=PD;
	loop_until_bit_is_set(UCSRA,UDRE);		
	UDR=PD>>8;
	while(potvrzeni==1);
			potvrzeni=1;
	} while (oprava==1);
	oprava=0;

				
}

/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*--------------------------------------------------------------------zapis SPI--------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

void write_spi(uint8_t povel, uint8_t prikaz)
{   PORTB&=~(1<<PB4);
	SPDR=povel;						//nastaveni vstupu
	while(!odeslano);
	odeslano=0;	
	SPDR=prikaz;
	while(!odeslano);
	odeslano=0;
	PORTB|=(1<<PB4);
}
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/



